package flm.b4j.charts;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4j.objects.NodeWrapper;
import javafx.geometry.Side;
import javafx.scene.chart.Axis;
import javafx.scene.text.Font;

@BA.Hide
public class b4jAxis extends NodeWrapper<Axis<?>>
{
	void Init(BA ba, Axis<?> axis, String EventPrefix)
	{
		setObject(axis);
		super.Initialize(ba, EventPrefix);
	}

	/** Gets or sets whether the changes to axis range will be animated or not (default = True). */
	public boolean getAnimated()
	{
		return getObject().getAnimated();
	}
	public void setAnimated(boolean Animated)
	{
		getObject().setAnimated(Animated);
	}

	/** Gets or sets whether the axis determines its range from the data automatically (default = True). */
	public boolean getAutoRanging()
	{
		return getObject().isAutoRanging();
	}
	public void setAutoRanging(boolean AutoRanging)
	{
		getObject().setAutoRanging(AutoRanging);
	}

	/** Gets or sets the axis label. */
	public String getLabel()
	{
		return getObject().getLabel();
	}
	public void setLabel(String Label)
	{
		getObject().setLabel(Label);
	}

	public static final Side SIDE_BOTTOM = Side.BOTTOM;
	public static final Side SIDE_LEFT = Side.LEFT;
	public static final Side SIDE_RIGHT = Side.RIGHT;
	public static final Side SIDE_TOP = Side.TOP;

	/** Gets or sets the side of the plot which this axis is being drawn on (one of the SIDE_ constants). */
	public Side getSide()
	{
		return getObject().getSide();
	}
	public void setSide(Side Side)
	{
		getObject().setSide(Side);
	}

	/** Gets or sets the font for all tick labels. */
	public Font getTickLabelFont()
	{
		return getObject().getTickLabelFont();
	}
	public void setTickLabelFont(Font TickLabelFont)
	{
		getObject().setTickLabelFont(TickLabelFont);
	}

	/** Gets or sets the gap between the tick labels and tick mark lines. */
	public double getTickLabelGap()
	{
		return getObject().getTickLabelGap();
	}
	public void setTickLabelGap(double TickLabelGap)
	{
		getObject().setTickLabelGap(TickLabelGap);
	}

	/** Gets or sets the rotation in degrees of tick mark labels from their normal horizontal. */
	public double getTickLabelRotation()
	{
		return getObject().getTickLabelRotation();
	}
	public void setTickLabelRotation(double TickLabelRotation)
	{
		getObject().setTickLabelRotation(TickLabelRotation);
	}

	/** Gets or sets whether tick mark labels should be displayed (default = True). */
	public boolean getTickLabelsVisible()
	{
		return getObject().isTickLabelsVisible();
	}
	public void setTickLabelsVisible(boolean TickLabelsVisible)
	{
		getObject().setTickLabelsVisible(TickLabelsVisible);
	}

	/** Gets or sets the length of tick mark lines. */
	public double getTickLength()
	{
		return getObject().getTickLength();
	}
	public void setTickLength(double TickLength)
	{
		getObject().setTickLength(TickLength);
	}

	/** Gets or sets whether tick marks should be displayed (default = True). */
	public boolean getTickMarkVisible()
	{
		return getObject().isTickMarkVisible();
	}
	public void setTickMarkVisible(boolean TickMarkVisible)
	{
		getObject().setTickMarkVisible(TickMarkVisible);
	}

	/** Returns the nearest data value to the given pixel position or Null if not on axis. */
	public Object GetValueForDisplay(double Position)
	{
		return getObject().getValueForDisplay(Position);
	}
}
