package flm.b4j.charts;

import anywheresoftware.b4a.BA;
import javafx.scene.chart.CategoryAxis;

@BA.ShortName("CategoryAxis")
public class b4jCategoryAxis extends b4jAxis
{
	public void Initialize(BA ba, String EventPrefix)
	{
		Init(ba, new CategoryAxis(), EventPrefix);
	}

	private CategoryAxis getAxisObj()
	{
		return (CategoryAxis) getObject();
	}

	/** Gets the display position along this axis for a given value. If the value is not equal to any of the categories, NaN is returned. */
	public double GetDisplayPosition(String Value)
	{
		return getAxisObj().getDisplayPosition(Value);
	}

	/** Gets the gap between one category and the next along this axis. */
	public double getCategorySpacing()
	{
		return getAxisObj().getCategorySpacing();
	}

	/** Gets or sets the margin between the axis start and the first tick-mark. */
	public double getStartMargin()
	{
		return getAxisObj().getStartMargin();
	}
	public void setStartMargin(double Margin)
	{
		getAxisObj().setStartMargin(Margin);
	}

	/** Gets or sets the margin between the last tick mark and the axis end. */
	public double getEndMargin()
	{
		return getAxisObj().getEndMargin();
	}
	public void setEndMargin(double Margin)
	{
		getAxisObj().setEndMargin(Margin);
	}

	/** Gets or sets whether half the space between ticks is left at the start and end (default = True). */
	public boolean getGapStartAndEnd()
	{
		return getAxisObj().isGapStartAndEnd();
	}
	public void setGapStartAndEnd(boolean Enable)
	{
		getAxisObj().setGapStartAndEnd(Enable);
	}
}
