package flm.b4j.charts;

import anywheresoftware.b4a.BA;
import javafx.scene.chart.NumberAxis;
import javafx.util.StringConverter;

@BA.ShortName("NumberAxis")
public class b4jNumberAxis extends b4jAxis
{
	public void Initialize(final BA ba, String EventPrefix)
	{
		Init(ba, new NumberAxis(), EventPrefix);
		final String evtToString = EventPrefix.toLowerCase(BA.cul) + "_tostring";
		if (ba.subExists(evtToString)) {
			StringConverter<Number> SC = new StringConverter<Number>()
			{
				@Override
				public Number fromString(String str) {
					return Double.parseDouble(str);
				}

				@Override
				public String toString(Number nbr) {
					Object Obj = ba.raiseEvent(this, evtToString, new Object[] { nbr });
					if (Obj instanceof String)
						return (String) Obj;
					else
						return null;
				}
			};
			getAxisObj().setTickLabelFormatter(SC);
		}
		else
			getAxisObj().setTickLabelFormatter(null);
	}

	private NumberAxis getAxisObj()
	{
		return (NumberAxis) getObject();
	}

	/** Gets the display position along this axis for a given value. If the value is not in the current range, the returned value will be an extrapolation of the display position. */
	public double GetDisplayPosition(Number Value)
	{
		return getAxisObj().getDisplayPosition(Value);
	}

	/** Gets or sets the value for the lower bound of this axis, i.e. min value. This is automatically set if AutoRanging is True. */
	public double getLowerBound()
	{
		return getAxisObj().getLowerBound();
	}
	public void setLowerBound(double LowerBound)
	{
		getAxisObj().setLowerBound(LowerBound);
	}

	/** Gets or sets the number of minor tick divisions to be displayed between each major tick mark. */
	public int getMinorTickCount()
	{
		return getAxisObj().getMinorTickCount() - 1;
	}
	public void setMinorTickCount(int MinorTickCount)
	{
		getAxisObj().setMinorTickCount(MinorTickCount + 1);
	}

	/** Gets or sets the length of minor tick mark lines. */
	public double getMinorTickLength()
	{
		return getAxisObj().getMinorTickLength();
	}
	public void setMinorTickLength(double MinorTickLength)
	{
		getAxisObj().setMinorTickLength(MinorTickLength);
	}

	/** Gets or sets whether minor tick marks should be displayed (default = True). */
	public boolean getMinorTickMarkVisible()
	{
		return getAxisObj().isMinorTickVisible();
	}
	public void setMinorTickMarkVisible(boolean MinorTickMarkVisible)
	{
		getAxisObj().setMinorTickVisible(MinorTickMarkVisible);
	}

	/** Gets or sets the value for the upper bound of this axis, i.e. max value. This is automatically set if AutoRanging is True. */
	public double getUpperBound()
	{
		return getAxisObj().getUpperBound();
	}
	public void setUpperBound(double UpperBound)
	{
		getAxisObj().setUpperBound(UpperBound);
	}

	/** Returns the display position of the zero line along this axis, or NaN if zero is not in current range. */
	public double getZeroPosition()
	{
		return getAxisObj().getZeroPosition();
	}
}
