package flm.b4j.charts;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import javafx.collections.ObservableList;
import javafx.scene.chart.XYChart.Data;
import javafx.scene.chart.XYChart.Series;

@BA.ShortName("XYSeries")
@SuppressWarnings("rawtypes")
public class b4jXYSeries extends AbsObjectWrapper<Series>
{
	public void Initialize(String Name)
	{
		Series _XY = new Series();
		_XY.setName(Name);
		super.setObject(_XY);
	}

	@SuppressWarnings({ "unchecked" })
	public void Add(Object X, Object Y)
	{
		getObject().getData().add(new Data(X, Y));
	}
	public void Add2(XYCoord XY)
	{
		Add(XY.X, XY.Y);
	}
	@SuppressWarnings("unchecked")
	public void Add3(Object X, Object Y, Object ExtraValue)
	{
		getObject().getData().add(new Data(X, Y, ExtraValue));
	}

	public XYCoord GetAt(int Position)
	{
		Data data = (Data) getObject().getData().get(Position);
		return new XYCoord(data.getXValue(), data.getYValue());
	}

	public Object GetExtraValueAt(int Position)
	{
		Data data = (Data) getObject().getData().get(Position);
		return data.getExtraValue();
	}

	public int IndexOf(Object X, Object Y)
	{
		ObservableList list = getObject().getData();
		for(int i = 0; i < list.size(); i++)
		{
			Data data = (Data) list.get(i);
			if (data.getXValue().equals(X) && data.getYValue().equals(Y))
				return i;
		}
		return -1;
	}
	public int IndexOf2(XYCoord XY)
	{
		return IndexOf(XY.X, XY.Y);
	}
	public int IndexOf3(Object X, Object Y, Object ExtraValue)
	{
		ObservableList list = getObject().getData();
		for(int i = 0; i < list.size(); i++)
		{
			Data data = (Data) list.get(i);
			if (data.getXValue().equals(X) && data.getYValue().equals(Y) && data.getExtraValue().equals(ExtraValue))
				return i;
		}
		return -1;
	}

	public void RemoveAt(int Position)
	{
		getObject().getData().remove(Position);
	}

	/** Removes all data items from StartPosition (inclusive) to EndPosition (exclusive). */
	public void RemoveRange(int StartPosition, int EndPosition)
	{
		getObject().getData().remove(StartPosition, EndPosition);
	}

	public void Clear()
	{
		getObject().getData().clear();
	}

	/** Returns the number of data items in this series. */
	public int Size()
	{
		return getObject().getData().size();
	}

	/** Returns the chart this series belongs to. */
	public Object getChart()
	{
		return getObject().getChart();
	}

	/** Gets or sets the user displayable name for this series. */
	public String getName()
	{
		return getObject().getName();
	}
	public void setName(String Name)
	{
		getObject().setName(Name);
	}
}
